#define PI 3.141592653589793238463

#define PI 3.141592653589793238463

DWORD EncodeNormal(double x, double y, double z)
{
	if (y < 0.0)
	{
		x = -x;
		y = -y;
		z = -z;
	}

	double dAngle1 = atan2(z, x);
	if (dAngle1 < 0.0)
		dAngle1 += 2 * PI;

	DWORD dwAngle1 = (DWORD)round(dAngle1 / (2.0 * PI) * 89.0) % 89;
	dwAngle1 = 88 - dwAngle1;

	double dAngle2 = acos(y);

	DWORD dwAngle2 = (DWORD)round(dAngle2 / (PI / 2.0) * 23.0);

	DWORD dwRet = dwAngle2 * 89 + dwAngle1;

	// This works because in the case of y = 1.0, x & z will be 0,
	// so 23 * 89 is the highest number we need
	dwRet = (dwRet >= 89) ? dwRet - 88 : 0;

	return dwRet;
}

void DecodeNormal(DWORD n, double* x, double* y, double* z)
{
    // A1(0-23)*89+A2(0-88)
    // Normally the highest number would be 23 * 89 + 88 = 2136,
    // but because in the case of A1=0, we know Y=1.0, so X=Z=0.0, so A2 = 0,
    // we compressed the range 0-88 down to 0
    // In the case of A1=0, sin(A1)=0, so x & y will be 0 for any value
    // from 0 to 88 below
    n = n + 88;

    // extract the original angles
    // Angle1 = Z to X-axis
    // Angle2 = Y to X-axis
    DWORD dwAngle1 = 88 - n % 89;
    DWORD dwAngle2 = n / 89;

    // convert the angles to radians
    double dAngle1 = dwAngle1 / 88.0 * 2.0 * PI;
    double dAngle2 = dwAngle2 / 23.0 * PI / 2.0;

    // insure angle 2 is in the range [-PI, PI]
    if (dAngle2 > PI)
        dAngle2 -= 2 * PI;

    // convert the angles to coords in the range [0, -1]
    *z = sin(dAngle1) * sin(dAngle2);
    *x = cos(dAngle1) * sin(dAngle2);
    *y = cos(dAngle2);
}
